// Reviver (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{

	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool fsave(char *_fname, unsigned char *_pt, int _size)
{
	fp = fopen(_fname,"wb");
	printf ("cutting ... %s\n",_fname);
	fwrite(_pt, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[11];
	int i;
	int start,size;
	int disk2=0;

	unsigned char id_a[] = "\'REVIVER\' by ARSYS. Tux.K.Y VER 1.0 MASTER";
	unsigned char id_b[] = "\'REVIVER\' by ARSYS. Tux.K.Y VER 1.0 DATA  ";
	unsigned char id_c[] = "\'REVIVER\' by ARSYS. Tux.K.Y VER 1.0 USER  ";

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x05);
		disk.ReadDATA(2, 1, 0, 1, 3, buff, 0x400);
		if (!memcmp(buff, id_a, sizeof(id_a)))
		{
			printf("DISK 1 (MASTER DISK) F܂.\n");
			fcut("PROG", 0x02, 0x01, 0x00, 0x02, 0x03, 0x0000, 0x4800);
			// PSG
			if (!disk.ReadDATA(0x0d, 0x06, 0x01, 0x01, 0x03, buff, 0x4000)) return 1;
			for (i=0; i<10; i++)
			{
				start = buff[i*4]   + buff[i*4+1]*0x100;
				size  = buff[i*4+2] + buff[i*4+3]*0x100;
				sprintf(fname,"MUS%02dP",i+12);
				fsave(fname, &buff[start], size);
			}
			// FM
			if (!disk.ReadDATA(0x0e, 0x07, 0x00, 0x05, 0x03, buff, 0x4000)) return 1;
			for (i=0; i<11; i++)
			{
				start = buff[i*4]   + buff[i*4+1]*0x100;
				size  = buff[i*4+2] + buff[i*4+3]*0x100;
				sprintf(fname,"MUS%02dF",i+12);
				fsave(fname, &buff[start], size);
			}
		}
		else if (!memcmp(buff, id_b, sizeof(id_b)) || !memcmp(buff, id_c, sizeof(id_c))) 
		{
			if (!memcmp(buff, id_b, sizeof(id_b)))
			{
				printf("DISK 2 (DATA DISK) F܂.\n");
			}
			else
			{
				printf("USER DISK F܂.\n");
			}
			if (disk2) continue;		// ɐ؂oς݂̏ꍇ
			// PSG
			if (!disk.ReadDATA(0x3e, 0x1f, 0x00, 0x01, 0x03, buff, 0x1c00)) return 1;
			for (i=0; i<11; i++)
			{
				start = buff[i*4]   + buff[i*4+1]*0x100;
				size  = buff[i*4+2] + buff[i*4+3]*0x100;
				sprintf(fname,"MUS%02dP",i+1);
				fsave(fname, &buff[start], size);
			}
			// FM
			if (!disk.ReadDATA(0x3f, 0x1f, 0x01, 0x03, 0x03, buff, 0x2800)) return 1;
			for (i=0; i<11; i++)
			{
				start = buff[i*4]   + buff[i*4+1]*0x100;
				size  = buff[i*4+2] + buff[i*4+3]*0x100;
				sprintf(fname,"MUS%02dF",i+1);
				fsave(fname, &buff[start], size);
			}
			disk2++;
		}
	}
	return 0;
}

